searchNodes=[{"doc":"Lightweight Json API server, embeddable into any project Camarero is a ready-to-use solution to add some JSON API functionality to your existing application, or to implement the read-only JSON API from the scratch when more sophisticated (read: heavy) solutions are not desirable. It is designed to be very simple and handy for read-only web access to the data. It might be a good candidate to replace Redis or any other key-value store. It is blazingly, deadly fast . Here are response times for the 1M key-value storage behind. Implementation details Camarero is supposed to be plugged into the functional application. It handles the configured routes/endpoints by delegating to the configured handler modules. The simplest configuration might looks like: config :camarero , carta : [ Camarero.Carta.Heartbeat ] , root : &quot;api/v1&quot; The above is the default; /api/v1 would be the root of the web server, single Camarero.Carta.Heartbeat module is declared as handler. The handlers might be also added dynamically by calls to Camarero.Catering.route! . Handlers Handler is a module implementing Camarero.Plato behaviour. It consists of methods to manipulate the conteiner behind it. Any module might implement this behaviour to be used as a handler for incoming HTTP requests. There is also Camarero.Tapas behaviour scaffolding the container implementation inside Camarero.Plato . The default implementation using %{} map as a container, looks pretty simple: defmodule Camarero.Carta.Heartbeat do use Camarero end Three different scaffolding implementations are currently supported with scaffold: :impl keyword parameter passed to use Camarero : scaffold: :full [ default ] — the full implementation of Camarero.Plato is used; scaffold: :access — Camarero.Tapas implementation is scaffolded only; scaffold: :none — no scaffold is used. This is an exact exerpt from Heartbeat module that comes with this package. For more complicated/sophisticated usages please refer to the documentation . All the methods from both Camarero.Tapas and Camarero.Plato default implementations are overridable. E. g. to use the custom route for the module (default is the not fully qualified underscored module name,) as well as custom container, one might do the following: defmodule Camarero.Carta.Heartbeat do use Camarero , into : % MyStructWithAccessBehaviour { } @impl Camarero.Plato def plato_route ( ) , do : &quot;internal/heartbeat&quot; end Web server config Camarero runs over Cowboy2 with Plug . To configure Cowboy , one might specify in the config.exs file: config :camarero , cowboy : [ port : 4001 , scheme : :http , options : [ ] ] Installation def deps do [ { :camarero , &quot;~&gt; 0.4&quot; } ] end Changelog 0.13 Plato.reshape/1 to allow reshaping of any incoming data into expected %{&quot;key&quot; =&gt; _, &quot;value&quot; =&gt; _} 0.7 Added support for HTTP PUT method 0.5 Ability to subscribe to incoming requests with Envío.Subscriber (see test/envio_test.exs for inspiration.) 0.4 basic CRUD ( GET / , GET /:id , POST / , DELETE /:id ), better support for many handlers, response_as: :value to return raw values instead of valid JSON objects. Is it of any good? Sure it is. Benchmarks To benchmark the application one should install wrk , run the application and then run the wrk.sh script located in wrk folder. Here are the results it produced on my laptop. === === === === === === === === === === === === === === === === === === === === === == NB ! Make sure you have a running Camarero app : mix clean &amp;&amp; mix run -- preload - modules -- no - halt === === === === === === === === === === === === === === === === === === === === === == Performing 10 sec POSTs and 5 sec GETs afterwards . This will INSERT 300 K key - values approx and READ 200 K approx . === === === === === === === === === === === === === === === === === === === === === == Running 10 s test @ http :/ / 127.0 . 0.1 : 4001 / api / v1 / crud 24 threads and 1000 connections Thread Stats Avg Stdev Max + / - Stdev Latency 44.91 ms 48.53 ms 422.59 ms 83.52 % Req / Sec 1.29 k 212.59 3.09 k 74.36 % 311912 requests in 10.10 s , 42.59 MB read Requests / sec : 30884.14 Transfer / sec : 4.22 MB Running 5 s test @ http :/ / 127.0 . 0.1 : 4001 / api / v1 / crud 24 threads and 1000 connections Thread Stats Avg Stdev Max + / - Stdev Latency 39.35 ms 45.92 ms 401.63 ms 84.53 % Req / Sec 1.48 k 375.94 4.71 k 79.09 % 179565 requests in 5.10 s , 30.11 MB read Requests / sec : 35211.34 Transfer / sec : 5.90 MB === === === === === === === === === === === === === === === === === === === === === == Performing 10 sec POSTs and 5 sec DELETEs afterwards . This will INSERT 300 K key - values approx and DELETE 200 K approx . === === === === === === === === === === === === === === === === === === === === === == Running 10 s test @ http :/ / 127.0 . 0.1 : 4001 / api / v1 / crud 24 threads and 1000 connections Thread Stats Avg Stdev Max + / - Stdev Latency 46.32 ms 52.38 ms 457.89 ms 84.01 % Req / Sec 1.31 k 302.33 5.09 k 79.26 % 316401 requests in 10.10 s , 43.20 MB read Requests / sec : 31332.56 Transfer / sec : 4.28 MB Running 5 s test @ http :/ / 127.0 . 0.1 : 4001 / api / v1 / crud 24 threads and 1000 connections Thread Stats Avg Stdev Max + / - Stdev Latency 40.17 ms 46.46 ms 406.37 ms 84.13 % Req / Sec 1.49 k 360.10 6.55 k 84.83 % 179722 requests in 5.10 s , 38.97 MB read Requests / sec : 35241.01 Transfer / sec : 7.64 MB === === === === === === === === === === === === === === === === === === === === === == Documentation","ref":"Camarero.html","title":"Camarero","type":"module"},{"doc":"The DynamicSupervisor to manage all the handlers. Handlers might be added through config.exs file statically or via call to route!/1 dynamically. The latter accepts all types of child_spec acceptable by DynamicSupervisor.start_child/2 . This module is started in the application supervision tree and keeps track on all the handlers.","ref":"Camarero.Catering.html","title":"Camarero.Catering","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Camarero.Catering.html#child_spec/1","title":"Camarero.Catering.child_spec/1","type":"function"},{"doc":"Declares and stores the new route. If the route is already set, logs an error message to the log and acts as NOOP.","ref":"Camarero.Catering.html#route!/1","title":"Camarero.Catering.route!/1","type":"function"},{"doc":"Starts the DynamicSupervisor and Camarero.Catering.Routes , linked to the current process. Upon start, loads :camarero, :carta config setting and adds routes for all the statically configured handlers.","ref":"Camarero.Catering.html#start_link/1","title":"Camarero.Catering.start_link/1","type":"function"},{"doc":"This behaviour is high-level abstraction of the container begind handlers. Aññ handlers are supposed to implement this behaviour. The simplest way is to use Camarero.Plato in the handler module; that will inject the default boilerlate using %{binary() =&gt; any()} map as a container behind. Default implementation uses Camarero.Tapas as low-level container implementation.","ref":"Camarero.Plato.html","title":"Camarero.Plato","type":"behaviour"},{"doc":"Returns the container itself, as is","ref":"Camarero.Plato.html#c:plato_all/0","title":"Camarero.Plato.plato_all/0","type":"callback"},{"doc":"Deletes the key-value pair for the key specified","ref":"Camarero.Plato.html#c:plato_delete/1","title":"Camarero.Plato.plato_delete/1","type":"callback"},{"doc":"Returns the value for the key specified","ref":"Camarero.Plato.html#c:plato_get/1","title":"Camarero.Plato.plato_get/1","type":"callback"},{"doc":"Sets the value for the key specified (intended to be used from the application)","ref":"Camarero.Plato.html#c:plato_put/2","title":"Camarero.Plato.plato_put/2","type":"callback"},{"doc":"Returns the route this module is supposed to be mounted to","ref":"Camarero.Plato.html#c:plato_route/0","title":"Camarero.Plato.plato_route/0","type":"callback"},{"doc":"Returns the key-value map out of a random input","ref":"Camarero.Plato.html#c:reshape/1","title":"Camarero.Plato.reshape/1","type":"callback"},{"doc":"HTTP status code","ref":"Camarero.Plato.html#t:status_code/0","title":"Camarero.Plato.status_code/0","type":"type"},{"doc":"This behaviour is high-level abstraction of the container begind handlers. Aññ handlers are supposed to implement this behaviour. The simplest way is to use Camarero.Plato in the handler module; that will inject the default boilerlate using %{binary() =&gt; any()} map as a container behind. Default implementation uses Camarero.Tapas as low-level container implementation.","ref":"Camarero.Tapas.html","title":"Camarero.Tapas","type":"behaviour"},{"doc":"Deletes the key-value pair for the key specified from the container","ref":"Camarero.Tapas.html#c:tapas_delete/2","title":"Camarero.Tapas.tapas_delete/2","type":"callback"},{"doc":"Retrieves from the container and returns the value for the key specified","ref":"Camarero.Tapas.html#c:tapas_get/2","title":"Camarero.Tapas.tapas_get/2","type":"callback"},{"doc":"Returns the empty container to be used to store the data. The returned term must implement Access behaviour since it’d be used from CR[U]D operations ( tapas_get/2 , tapas_put/3 , and tapas_delete/2 ).","ref":"Camarero.Tapas.html#c:tapas_into/0","title":"Camarero.Tapas.tapas_into/0","type":"callback"},{"doc":"Sets the value for the key specified (intended to be used from the application)","ref":"Camarero.Tapas.html#c:tapas_put/3","title":"Camarero.Tapas.tapas_put/3","type":"callback"},{"doc":"Camarero.Tapas allows anything implementing Access behaviour as a container","ref":"Camarero.Tapas.html#t:t/0","title":"Camarero.Tapas.t/0","type":"type"},{"doc":"Internal state for all the routes known to this application","ref":"Camarero.Catering.Routes.html","title":"Camarero.Catering.Routes","type":"module"},{"doc":"Internally stored map of routes to handlers","ref":"Camarero.Catering.Routes.html#child_spec/1","title":"Camarero.Catering.Routes.child_spec/1","type":"function"},{"doc":"Retrieves the handler for the route specified","ref":"Camarero.Catering.Routes.html#get/1","title":"Camarero.Catering.Routes.get/1","type":"function"},{"doc":"Stores a handler for the route specified","ref":"Camarero.Catering.Routes.html#put/2","title":"Camarero.Catering.Routes.put/2","type":"function"},{"doc":"Starts an agent linked to the current process","ref":"Camarero.Catering.Routes.html#start_link/2","title":"Camarero.Catering.Routes.start_link/2","type":"function"},{"doc":"Returns the whole mapping of routes to handlers","ref":"Camarero.Catering.Routes.html#state/0","title":"Camarero.Catering.Routes.state/0","type":"function"},{"doc":"","ref":"Camarero.Catering.Routes.html#t:t/0","title":"Camarero.Catering.Routes.t/0","type":"type"},{"doc":"Camarero","ref":"camarero.html","title":"Camarero","type":"extras"},{"doc":"Camarero is a ready-to-use solution to add some JSON API functionality to your existing application, or to implement the read-only JSON API from the scratch when more sophisticated (read: heavy) solutions are not desirable. It is designed to be very simple and handy for read-only web access to the data. It might be a good candidate to replace Redis or any other key-value store. It is blazingly, deadly fast . Here are response times for the 1M key-value storage behind.","ref":"camarero.html#lightweight-json-api-server-embeddable-into-any-project","title":"Camarero -      Lightweight Json API server, embeddable into any project","type":"extras"},{"doc":"Camarero is supposed to be plugged into the functional application. It handles the configured routes/endpoints by delegating to the configured handler modules. The simplest configuration might looks like: config :camarero , carta : [ Camarero.Carta.Heartbeat ] , root : &quot;api/v1&quot; The above is the default; /api/v1 would be the root of the web server, single Camarero.Carta.Heartbeat module is declared as handler. The handlers might be also added dynamically by calls to Camarero.Catering.route! . Handlers Handler is a module implementing Camarero.Plato behaviour. It consists of methods to manipulate the conteiner behind it. Any module might implement this behaviour to be used as a handler for incoming HTTP requests. There is also Camarero.Tapas behaviour scaffolding the container implementation inside Camarero.Plato . The default implementation using %{} map as a container, looks pretty simple: defmodule Camarero.Carta.Heartbeat do use Camarero end Three different scaffolding implementations are currently supported with scaffold: :impl keyword parameter passed to use Camarero : scaffold: :full [ default ] — the full implementation of Camarero.Plato is used; scaffold: :access — Camarero.Tapas implementation is scaffolded only; scaffold: :none — no scaffold is used. This is an exact exerpt from Heartbeat module that comes with this package. For more complicated/sophisticated usages please refer to the documentation . All the methods from both Camarero.Tapas and Camarero.Plato default implementations are overridable. E. g. to use the custom route for the module (default is the not fully qualified underscored module name,) as well as custom container, one might do the following: defmodule Camarero.Carta.Heartbeat do use Camarero , into : % MyStructWithAccessBehaviour { } @impl Camarero.Plato def plato_route ( ) , do : &quot;internal/heartbeat&quot; end Web server config Camarero runs over Cowboy2 with Plug . To configure Cowboy , one might specify in the config.exs file: config :camarero , cowboy : [ port : 4001 , scheme : :http , options : [ ] ]","ref":"camarero.html#implementation-details","title":"Camarero - Implementation details","type":"extras"},{"doc":"def deps do [ { :camarero , &quot;~&gt; 0.4&quot; } ] end","ref":"camarero.html#installation","title":"Camarero - Installation","type":"extras"},{"doc":"0.13 Plato.reshape/1 to allow reshaping of any incoming data into expected %{&quot;key&quot; =&gt; _, &quot;value&quot; =&gt; _} 0.7 Added support for HTTP PUT method 0.5 Ability to subscribe to incoming requests with Envío.Subscriber (see test/envio_test.exs for inspiration.) 0.4 basic CRUD ( GET / , GET /:id , POST / , DELETE /:id ), better support for many handlers, response_as: :value to return raw values instead of valid JSON objects.","ref":"camarero.html#changelog","title":"Camarero - Changelog","type":"extras"},{"doc":"Sure it is.","ref":"camarero.html#is-it-of-any-good","title":"Camarero - Is it of any good?","type":"extras"},{"doc":"To benchmark the application one should install wrk , run the application and then run the wrk.sh script located in wrk folder. Here are the results it produced on my laptop. === === === === === === === === === === === === === === === === === === === === === == NB ! Make sure you have a running Camarero app : mix clean &amp;&amp; mix run -- preload - modules -- no - halt === === === === === === === === === === === === === === === === === === === === === == Performing 10 sec POSTs and 5 sec GETs afterwards . This will INSERT 300 K key - values approx and READ 200 K approx . === === === === === === === === === === === === === === === === === === === === === == Running 10 s test @ http :/ / 127.0 . 0.1 : 4001 / api / v1 / crud 24 threads and 1000 connections Thread Stats Avg Stdev Max + / - Stdev Latency 44.91 ms 48.53 ms 422.59 ms 83.52 % Req / Sec 1.29 k 212.59 3.09 k 74.36 % 311912 requests in 10.10 s , 42.59 MB read Requests / sec : 30884.14 Transfer / sec : 4.22 MB Running 5 s test @ http :/ / 127.0 . 0.1 : 4001 / api / v1 / crud 24 threads and 1000 connections Thread Stats Avg Stdev Max + / - Stdev Latency 39.35 ms 45.92 ms 401.63 ms 84.53 % Req / Sec 1.48 k 375.94 4.71 k 79.09 % 179565 requests in 5.10 s , 30.11 MB read Requests / sec : 35211.34 Transfer / sec : 5.90 MB === === === === === === === === === === === === === === === === === === === === === == Performing 10 sec POSTs and 5 sec DELETEs afterwards . This will INSERT 300 K key - values approx and DELETE 200 K approx . === === === === === === === === === === === === === === === === === === === === === == Running 10 s test @ http :/ / 127.0 . 0.1 : 4001 / api / v1 / crud 24 threads and 1000 connections Thread Stats Avg Stdev Max + / - Stdev Latency 46.32 ms 52.38 ms 457.89 ms 84.01 % Req / Sec 1.31 k 302.33 5.09 k 79.26 % 316401 requests in 10.10 s , 43.20 MB read Requests / sec : 31332.56 Transfer / sec : 4.28 MB Running 5 s test @ http :/ / 127.0 . 0.1 : 4001 / api / v1 / crud 24 threads and 1000 connections Thread Stats Avg Stdev Max + / - Stdev Latency 40.17 ms 46.46 ms 406.37 ms 84.13 % Req / Sec 1.49 k 360.10 6.55 k 84.83 % 179722 requests in 5.10 s , 38.97 MB read Requests / sec : 35241.01 Transfer / sec : 7.64 MB === === === === === === === === === === === === === === === === === === === === === ==","ref":"camarero.html#benchmarks","title":"Camarero - Benchmarks","type":"extras"},{"doc":"","ref":"camarero.html#documentation","title":"Camarero - Documentation","type":"extras"}]